-- Different MUXes
-- Author: John Moskal
--  Created: 11-25-04
-- Modified: 11-25-04
--
-- Modifications:
--
------------------------------------------------------------------------------------------

library work;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity MUX2 is
port
(
        A, B:           in std_logic;
        SL:             in std_logic;
        R:              out std_logic
);
end entity MUX2;

architecture stuff of MUX2 is

begin
        R <= (not SL and A) or 
             (    SL and B);
             
end stuff;

---------------------------------------------------------------------
---------------------------------------------------------------------
library work;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity MUX4 is
port
(
        A, B, C, D:     in std_logic;
        SL:             in std_logic_vector(1 downto 0);
        R:              out std_logic
);
end entity MUX4;

architecture stuff of MUX4 is

begin
        R <= (not SL(1) and not SL(0) and A) or 
             (not SL(1) and     SL(0) and B) or
             (    SL(1) and not SL(0) and C) or 
             (    SL(1) and     SL(0) and D);
end stuff;

---------------------------------------------------------------------
---------------------------------------------------------------------

library work;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity MUX8 is
port
(
        I:              in std_logic_vector(7 downto 0);
        SL:             in std_logic_vector(2 downto 0);
        R:              out std_logic
);
end entity MUX8;

architecture stuff of MUX8 is

begin
        R <= (not SL(2) and not SL(1) and not SL(0) and I(0)) or
             (not SL(2) and not SL(1) and     SL(0) and I(1)) or
             (not SL(2) and     SL(1) and not SL(0) and I(2)) or
             (not SL(2) and     SL(1) and     SL(0) and I(3)) or
             (    SL(2) and not SL(1) and not SL(0) and I(4)) or
             (    SL(2) and not SL(1) and     SL(0) and I(5)) or
             (    SL(2) and     SL(1) and not SL(0) and I(6)) or
             (    SL(2) and     SL(1) and     SL(0) and I(7));


end stuff;

---------------------------------------------------------------------
---------------------------------------------------------------------

library WORK;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
-------------------------------------------
 
entity mux16to1 is 
port
(
        sel:    in std_logic_vector(3 downto 0); 
        inp:    in std_logic_vector(15 downto 0);  
        outp:   out std_logic
); 
end entity mux16to1; 
-------------------------------------------
 
architecture stuff of mux16to1 is 
begin 

        muxproc: process (sel, inp) 
        begin 
                case sel is  
                        when "0000"  => outp <= inp(0);  
                        when "0001"  => outp <= inp(1);  
                        when "0010"  => outp <= inp(2);  
                        when "0011"  => outp <= inp(3);  
                        when "0100"  => outp <= inp(4);  
                        when "0101"  => outp <= inp(5);  
                        when "0110"  => outp <= inp(6);  
                        when "0111"  => outp <= inp(7);  
                        when "1000"  => outp <= inp(8);  
                        when "1001"  => outp <= inp(9);  
                        when "1010"  => outp <= inp(10);  
                        when "1011"  => outp <= inp(11);  
                        when "1100"  => outp <= inp(12);  
                        when "1101"  => outp <= inp(13); 
                        when "1110"  => outp <= inp(14);  
                        when "1111"  => outp <= inp(15);
                        when others  => outp <= 'X';
                end case;  
        end process muxproc; 
end stuff; 

---------------------------------------------------------------------
---------------------------------------------------------------------

library work;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity MUX32 is
port
(
        I00,I01,I02,I03,I04,I05,I06,I07,
        I08,I09,I10,I11,I12,I13,I14,I15,
        I16,I17,I18,I19,I20,I21,I22,I23,
        I24,I25,I26,I27,I28,I29,I30,I31:   in std_logic;
        SL:                                in std_logic_vector(4 downto 0);
        R:                                 out std_logic
);
end entity MUX32;

architecture stuff of MUX32 is

begin
        R <= (not SL(4) and not SL(3) and not SL(2) and not SL(1) and not SL(0) and I00) or
             (not SL(4) and not SL(3) and not SL(2) and not SL(1) and     SL(0) and I01) or
             (not SL(4) and not SL(3) and not SL(2) and     SL(1) and not SL(0) and I02) or
             (not SL(4) and not SL(3) and not SL(2) and     SL(1) and     SL(0) and I03) or
             (not SL(4) and not SL(3) and     SL(2) and not SL(1) and not SL(0) and I04) or
             (not SL(4) and not SL(3) and     SL(2) and not SL(1) and     SL(0) and I05) or
             (not SL(4) and not SL(3) and     SL(2) and     SL(1) and not SL(0) and I06) or
             (not SL(4) and not SL(3) and     SL(2) and     SL(1) and     SL(0) and I07) or
             (not SL(4) and     SL(3) and not SL(2) and not SL(1) and not SL(0) and I08) or
             (not SL(4) and     SL(3) and not SL(2) and not SL(1) and     SL(0) and I09) or
             (not SL(4) and     SL(3) and not SL(2) and     SL(1) and not SL(0) and I10) or
             (not SL(4) and     SL(3) and not SL(2) and     SL(1) and     SL(0) and I11) or
             (not SL(4) and     SL(3) and     SL(2) and not SL(1) and not SL(0) and I12) or
             (not SL(4) and     SL(3) and     SL(2) and not SL(1) and     SL(0) and I13) or
             (not SL(4) and     SL(3) and     SL(2) and     SL(1) and not SL(0) and I14) or
             (not SL(4) and     SL(3) and     SL(2) and     SL(1) and     SL(0) and I15) or
             (    SL(4) and not SL(3) and not SL(2) and not SL(1) and not SL(0) and I16) or
             (    SL(4) and not SL(3) and not SL(2) and not SL(1) and     SL(0) and I17) or
             (    SL(4) and not SL(3) and not SL(2) and     SL(1) and not SL(0) and I18) or
             (    SL(4) and not SL(3) and not SL(2) and     SL(1) and     SL(0) and I19) or
             (    SL(4) and not SL(3) and     SL(2) and not SL(1) and not SL(0) and I20) or
             (    SL(4) and not SL(3) and     SL(2) and not SL(1) and     SL(0) and I21) or
             (    SL(4) and not SL(3) and     SL(2) and     SL(1) and not SL(0) and I22) or
             (    SL(4) and not SL(3) and     SL(2) and     SL(1) and     SL(0) and I23) or
             (    SL(4) and     SL(3) and not SL(2) and not SL(1) and not SL(0) and I24) or
             (    SL(4) and     SL(3) and not SL(2) and not SL(1) and     SL(0) and I25) or
             (    SL(4) and     SL(3) and not SL(2) and     SL(1) and not SL(0) and I26) or
             (    SL(4) and     SL(3) and not SL(2) and     SL(1) and     SL(0) and I27) or
             (    SL(4) and     SL(3) and     SL(2) and not SL(1) and not SL(0) and I28) or
             (    SL(4) and     SL(3) and     SL(2) and not SL(1) and     SL(0) and I29) or
             (    SL(4) and     SL(3) and     SL(2) and     SL(1) and not SL(0) and I30) or
             (    SL(4) and     SL(3) and     SL(2) and     SL(1) and     SL(0) and I31);
        
end stuff;

-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity mux2_3 is
port
(
   A,B:   in std_logic_vector(2 downto 0);
   SL:    in std_logic;
   R:     out std_logic_vector(2 downto 0)
);
end entity mux2_3;

------------------------------------------------------------------------------------------

architecture stuff of mux2_3 is

-- COMPONENTS --

component MUX2 is
port
(
        A, B:           in std_logic;
        SL:             in std_logic;
        R:              out std_logic
);
end component MUX2;

-- HDL --

begin

   M00:   MUX2 port map(A(00), B(00), SL, R(00));
   M01:   MUX2 port map(A(01), B(01), SL, R(01));
   M02:   MUX2 port map(A(02), B(02), SL, R(02));

end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity mux2_5 is
port
(
   A,B:   in std_logic_vector(4 downto 0);
   SL:    in std_logic;
   R:     out std_logic_vector(4 downto 0)
);
end entity mux2_5;

------------------------------------------------------------------------------------------

architecture stuff of mux2_5 is

-- COMPONENTS --

component MUX2 is
port
(
        A, B:           in std_logic;
        SL:             in std_logic;
        R:              out std_logic
);
end component MUX2;

-- HDL --

begin

   M00:   MUX2 port map(A(00), B(00), SL, R(00));
   M01:   MUX2 port map(A(01), B(01), SL, R(01));
   M02:   MUX2 port map(A(02), B(02), SL, R(02));
   M03:   MUX2 port map(A(03), B(03), SL, R(03));
   M04:   MUX2 port map(A(04), B(04), SL, R(04));

end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------


library work;
library ieee;
use ieee.std_logic_1164.all;

entity mux2_32 is
port
(
   A,B:   in std_logic_vector(31 downto 0);
   SL:    in std_logic;
   R:     out std_logic_vector(31 downto 0)
);
end entity mux2_32;

------------------------------------------------------------------------------------------

architecture stuff of mux2_32 is

-- COMPONENTS --

component MUX2 is
port
(
        A, B:           in std_logic;
        SL:             in std_logic;
        R:              out std_logic
);
end component MUX2;

-- SIGNALS --

-- HDL --

begin

   M00:   MUX2 port map(A(00), B(00), SL, R(00));
   M01:   MUX2 port map(A(01), B(01), SL, R(01));
   M02:   MUX2 port map(A(02), B(02), SL, R(02));
   M03:   MUX2 port map(A(03), B(03), SL, R(03));
   M04:   MUX2 port map(A(04), B(04), SL, R(04));
   M05:   MUX2 port map(A(05), B(05), SL, R(05));
   M06:   MUX2 port map(A(06), B(06), SL, R(06));
   M07:   MUX2 port map(A(07), B(07), SL, R(07));
   M08:   MUX2 port map(A(08), B(08), SL, R(08));
   M09:   MUX2 port map(A(09), B(09), SL, R(09));
   M10:   MUX2 port map(A(10), B(10), SL, R(10));
   M11:   MUX2 port map(A(11), B(11), SL, R(11));
   M12:   MUX2 port map(A(12), B(12), SL, R(12));
   M13:   MUX2 port map(A(13), B(13), SL, R(13));
   M14:   MUX2 port map(A(14), B(14), SL, R(14));
   M15:   MUX2 port map(A(15), B(15), SL, R(15));
   M16:   MUX2 port map(A(16), B(16), SL, R(16));
   M17:   MUX2 port map(A(17), B(17), SL, R(17));
   M18:   MUX2 port map(A(18), B(18), SL, R(18));
   M19:   MUX2 port map(A(19), B(19), SL, R(19));
   M20:   MUX2 port map(A(20), B(20), SL, R(20));
   M21:   MUX2 port map(A(21), B(21), SL, R(21));
   M22:   MUX2 port map(A(22), B(22), SL, R(22));
   M23:   MUX2 port map(A(23), B(23), SL, R(23));
   M24:   MUX2 port map(A(24), B(24), SL, R(24));
   M25:   MUX2 port map(A(25), B(25), SL, R(25));
   M26:   MUX2 port map(A(26), B(26), SL, R(26));
   M27:   MUX2 port map(A(27), B(27), SL, R(27));
   M28:   MUX2 port map(A(28), B(28), SL, R(28));
   M29:   MUX2 port map(A(29), B(29), SL, R(29));
   M30:   MUX2 port map(A(30), B(30), SL, R(30));
   M31:   MUX2 port map(A(31), B(31), SL, R(31));

end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity mux4_32 is
port
(
   A,B,C,D:   in std_logic_vector(31 downto 0);
   SL:        in std_logic_vector(1 downto 0);
   R:         out std_logic_vector(31 downto 0)
);
end entity mux4_32;

architecture stuff of mux4_32 is

-- COMPONENTS --

component MUX4 is
port
(
        A, B, C, D:     in std_logic;
        SL:             in std_logic_vector(1 downto 0);
        R:              out std_logic
);
end component MUX4;

-- SIGNALS --

-- HDL --

begin

   M00:   MUX4 port map(A(00), B(00), C(00), D(00), SL, R(00));
   M01:   MUX4 port map(A(01), B(01), C(01), D(01), SL, R(01));
   M02:   MUX4 port map(A(02), B(02), C(02), D(02), SL, R(02));
   M03:   MUX4 port map(A(03), B(03), C(03), D(03), SL, R(03));
   M04:   MUX4 port map(A(04), B(04), C(04), D(04), SL, R(04));
   M05:   MUX4 port map(A(05), B(05), C(05), D(05), SL, R(05));
   M06:   MUX4 port map(A(06), B(06), C(06), D(06), SL, R(06));
   M07:   MUX4 port map(A(07), B(07), C(07), D(07), SL, R(07));
   M08:   MUX4 port map(A(08), B(08), C(08), D(08), SL, R(08));
   M09:   MUX4 port map(A(09), B(09), C(09), D(09), SL, R(09));
   M10:   MUX4 port map(A(10), B(10), C(10), D(10), SL, R(10));
   M11:   MUX4 port map(A(11), B(11), C(11), D(11), SL, R(11));
   M12:   MUX4 port map(A(12), B(12), C(12), D(12), SL, R(12));
   M13:   MUX4 port map(A(13), B(13), C(13), D(13), SL, R(13));
   M14:   MUX4 port map(A(14), B(14), C(14), D(14), SL, R(14));
   M15:   MUX4 port map(A(15), B(15), C(15), D(15), SL, R(15));
   M16:   MUX4 port map(A(16), B(16), C(16), D(16), SL, R(16));
   M17:   MUX4 port map(A(17), B(17), C(17), D(17), SL, R(17));
   M18:   MUX4 port map(A(18), B(18), C(18), D(18), SL, R(18));
   M19:   MUX4 port map(A(19), B(19), C(19), D(19), SL, R(19));
   M20:   MUX4 port map(A(20), B(20), C(20), D(20), SL, R(20));
   M21:   MUX4 port map(A(21), B(21), C(21), D(21), SL, R(21));
   M22:   MUX4 port map(A(22), B(22), C(22), D(22), SL, R(22));
   M23:   MUX4 port map(A(23), B(23), C(23), D(23), SL, R(23));
   M24:   MUX4 port map(A(24), B(24), C(24), D(24), SL, R(24));
   M25:   MUX4 port map(A(25), B(25), C(25), D(25), SL, R(25));
   M26:   MUX4 port map(A(26), B(26), C(26), D(26), SL, R(26));
   M27:   MUX4 port map(A(27), B(27), C(27), D(27), SL, R(27));
   M28:   MUX4 port map(A(28), B(28), C(28), D(28), SL, R(28));
   M29:   MUX4 port map(A(29), B(29), C(29), D(29), SL, R(29));
   M30:   MUX4 port map(A(30), B(30), C(30), D(30), SL, R(30));
   M31:   MUX4 port map(A(31), B(31), C(31), D(31), SL, R(31));
    
end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity mux32_32 is
port
(
   I00,I01,I02,I03,I04,I05,I06,I07,
   I08,I09,I10,I11,I12,I13,I14,I15,
   I16,I17,I18,I19,I20,I21,I22,I23,
   I24,I25,I26,I27,I28,I29,I30,I31:   in std_logic_vector(31 downto 0);
   SL:                                in std_logic_vector(4 downto 0);
   R:                                 out std_logic_vector(31 downto 0)
);
end entity mux32_32;

architecture stuff of mux32_32 is

-- COMPONENTS --

component MUX32 is
port
(
        I00,I01,I02,I03,I04,I05,I06,I07,
        I08,I09,I10,I11,I12,I13,I14,I15,
        I16,I17,I18,I19,I20,I21,I22,I23,
        I24,I25,I26,I27,I28,I29,I30,I31:   in std_logic;
        SL:                                in std_logic_vector(4 downto 0);
        R:                                 out std_logic
);
end component MUX32;

-- SIGNALS --

-- HDL --

begin

M00:   MUX32 port map(I00(00), I01(00), I02(00), I03(00), I04(00), I05(00), I06(00), I07(00), I08(00), I09(00), I10(00), I11(00), I12(00), I13(00), I14(00), I15(00), I16(00), I17(00), I18(00), I19(00), I20(00), I21(00), I22(00), I23(00), I24(00), I25(00), I26(00), I27(00), I28(00), I29(00), I30(00), I31(00),  SL, R(00));
M01:   MUX32 port map(I00(01), I01(01), I02(01), I03(01), I04(01), I05(01), I06(01), I07(01), I08(01), I09(01), I10(01), I11(01), I12(01), I13(01), I14(01), I15(01), I16(01), I17(01), I18(01), I19(01), I20(01), I21(01), I22(01), I23(01), I24(01), I25(01), I26(01), I27(01), I28(01), I29(01), I30(01), I31(01),  SL, R(01));
M02:   MUX32 port map(I00(02), I01(02), I02(02), I03(02), I04(02), I05(02), I06(02), I07(02), I08(02), I09(02), I10(02), I11(02), I12(02), I13(02), I14(02), I15(02), I16(02), I17(02), I18(02), I19(02), I20(02), I21(02), I22(02), I23(02), I24(02), I25(02), I26(02), I27(02), I28(02), I29(02), I30(02), I31(02),  SL, R(02));
M03:   MUX32 port map(I00(03), I01(03), I02(03), I03(03), I04(03), I05(03), I06(03), I07(03), I08(03), I09(03), I10(03), I11(03), I12(03), I13(03), I14(03), I15(03), I16(03), I17(03), I18(03), I19(03), I20(03), I21(03), I22(03), I23(03), I24(03), I25(03), I26(03), I27(03), I28(03), I29(03), I30(03), I31(03),  SL, R(03));
M04:   MUX32 port map(I00(04), I01(04), I02(04), I03(04), I04(04), I05(04), I06(04), I07(04), I08(04), I09(04), I10(04), I11(04), I12(04), I13(04), I14(04), I15(04), I16(04), I17(04), I18(04), I19(04), I20(04), I21(04), I22(04), I23(04), I24(04), I25(04), I26(04), I27(04), I28(04), I29(04), I30(04), I31(04),  SL, R(04));
M05:   MUX32 port map(I00(05), I01(05), I02(05), I03(05), I04(05), I05(05), I06(05), I07(05), I08(05), I09(05), I10(05), I11(05), I12(05), I13(05), I14(05), I15(05), I16(05), I17(05), I18(05), I19(05), I20(05), I21(05), I22(05), I23(05), I24(05), I25(05), I26(05), I27(05), I28(05), I29(05), I30(05), I31(05),  SL, R(05));
M06:   MUX32 port map(I00(06), I01(06), I02(06), I03(06), I04(06), I05(06), I06(06), I07(06), I08(06), I09(06), I10(06), I11(06), I12(06), I13(06), I14(06), I15(06), I16(06), I17(06), I18(06), I19(06), I20(06), I21(06), I22(06), I23(06), I24(06), I25(06), I26(06), I27(06), I28(06), I29(06), I30(06), I31(06),  SL, R(06));
M07:   MUX32 port map(I00(07), I01(07), I02(07), I03(07), I04(07), I05(07), I06(07), I07(07), I08(07), I09(07), I10(07), I11(07), I12(07), I13(07), I14(07), I15(07), I16(07), I17(07), I18(07), I19(07), I20(07), I21(07), I22(07), I23(07), I24(07), I25(07), I26(07), I27(07), I28(07), I29(07), I30(07), I31(07),  SL, R(07));
M08:   MUX32 port map(I00(08), I01(08), I02(08), I03(08), I04(08), I05(08), I06(08), I07(08), I08(08), I09(08), I10(08), I11(08), I12(08), I13(08), I14(08), I15(08), I16(08), I17(08), I18(08), I19(08), I20(08), I21(08), I22(08), I23(08), I24(08), I25(08), I26(08), I27(08), I28(08), I29(08), I30(08), I31(08),  SL, R(08));
M09:   MUX32 port map(I00(09), I01(09), I02(09), I03(09), I04(09), I05(09), I06(09), I07(09), I08(09), I09(09), I10(09), I11(09), I12(09), I13(09), I14(09), I15(09), I16(09), I17(09), I18(09), I19(09), I20(09), I21(09), I22(09), I23(09), I24(09), I25(09), I26(09), I27(09), I28(09), I29(09), I30(09), I31(09),  SL, R(09));
M10:   MUX32 port map(I00(10), I01(10), I02(10), I03(10), I04(10), I05(10), I06(10), I07(10), I08(10), I09(10), I10(10), I11(10), I12(10), I13(10), I14(10), I15(10), I16(10), I17(10), I18(10), I19(10), I20(10), I21(10), I22(10), I23(10), I24(10), I25(10), I26(10), I27(10), I28(10), I29(10), I30(10), I31(10),  SL, R(10));
M11:   MUX32 port map(I00(11), I01(11), I02(11), I03(11), I04(11), I05(11), I06(11), I07(11), I08(11), I09(11), I10(11), I11(11), I12(11), I13(11), I14(11), I15(11), I16(11), I17(11), I18(11), I19(11), I20(11), I21(11), I22(11), I23(11), I24(11), I25(11), I26(11), I27(11), I28(11), I29(11), I30(11), I31(11),  SL, R(11));
M12:   MUX32 port map(I00(12), I01(12), I02(12), I03(12), I04(12), I05(12), I06(12), I07(12), I08(12), I09(12), I10(12), I11(12), I12(12), I13(12), I14(12), I15(12), I16(12), I17(12), I18(12), I19(12), I20(12), I21(12), I22(12), I23(12), I24(12), I25(12), I26(12), I27(12), I28(12), I29(12), I30(12), I31(12),  SL, R(12));
M13:   MUX32 port map(I00(13), I01(13), I02(13), I03(13), I04(13), I05(13), I06(13), I07(13), I08(13), I09(13), I10(13), I11(13), I12(13), I13(13), I14(13), I15(13), I16(13), I17(13), I18(13), I19(13), I20(13), I21(13), I22(13), I23(13), I24(13), I25(13), I26(13), I27(13), I28(13), I29(13), I30(13), I31(13),  SL, R(13));
M14:   MUX32 port map(I00(14), I01(14), I02(14), I03(14), I04(14), I05(14), I06(14), I07(14), I08(14), I09(14), I10(14), I11(14), I12(14), I13(14), I14(14), I15(14), I16(14), I17(14), I18(14), I19(14), I20(14), I21(14), I22(14), I23(14), I24(14), I25(14), I26(14), I27(14), I28(14), I29(14), I30(14), I31(14),  SL, R(14));
M15:   MUX32 port map(I00(15), I01(15), I02(15), I03(15), I04(15), I05(15), I06(15), I07(15), I08(15), I09(15), I10(15), I11(15), I12(15), I13(15), I14(15), I15(15), I16(15), I17(15), I18(15), I19(15), I20(15), I21(15), I22(15), I23(15), I24(15), I25(15), I26(15), I27(15), I28(15), I29(15), I30(15), I31(15),  SL, R(15));
M16:   MUX32 port map(I00(16), I01(16), I02(16), I03(16), I04(16), I05(16), I06(16), I07(16), I08(16), I09(16), I10(16), I11(16), I12(16), I13(16), I14(16), I15(16), I16(16), I17(16), I18(16), I19(16), I20(16), I21(16), I22(16), I23(16), I24(16), I25(16), I26(16), I27(16), I28(16), I29(16), I30(16), I31(16),  SL, R(16));
M17:   MUX32 port map(I00(17), I01(17), I02(17), I03(17), I04(17), I05(17), I06(17), I07(17), I08(17), I09(17), I10(17), I11(17), I12(17), I13(17), I14(17), I15(17), I16(17), I17(17), I18(17), I19(17), I20(17), I21(17), I22(17), I23(17), I24(17), I25(17), I26(17), I27(17), I28(17), I29(17), I30(17), I31(17),  SL, R(17));
M18:   MUX32 port map(I00(18), I01(18), I02(18), I03(18), I04(18), I05(18), I06(18), I07(18), I08(18), I09(18), I10(18), I11(18), I12(18), I13(18), I14(18), I15(18), I16(18), I17(18), I18(18), I19(18), I20(18), I21(18), I22(18), I23(18), I24(18), I25(18), I26(18), I27(18), I28(18), I29(18), I30(18), I31(18),  SL, R(18));
M19:   MUX32 port map(I00(19), I01(19), I02(19), I03(19), I04(19), I05(19), I06(19), I07(19), I08(19), I09(19), I10(19), I11(19), I12(19), I13(19), I14(19), I15(19), I16(19), I17(19), I18(19), I19(19), I20(19), I21(19), I22(19), I23(19), I24(19), I25(19), I26(19), I27(19), I28(19), I29(19), I30(19), I31(19),  SL, R(19));
M20:   MUX32 port map(I00(20), I01(20), I02(20), I03(20), I04(20), I05(20), I06(20), I07(20), I08(20), I09(20), I10(20), I11(20), I12(20), I13(20), I14(20), I15(20), I16(20), I17(20), I18(20), I19(20), I20(20), I21(20), I22(20), I23(20), I24(20), I25(20), I26(20), I27(20), I28(20), I29(20), I30(20), I31(20),  SL, R(20));
M21:   MUX32 port map(I00(21), I01(21), I02(21), I03(21), I04(21), I05(21), I06(21), I07(21), I08(21), I09(21), I10(21), I11(21), I12(21), I13(21), I14(21), I15(21), I16(21), I17(21), I18(21), I19(21), I20(21), I21(21), I22(21), I23(21), I24(21), I25(21), I26(21), I27(21), I28(21), I29(21), I30(21), I31(21),  SL, R(21));
M22:   MUX32 port map(I00(22), I01(22), I02(22), I03(22), I04(22), I05(22), I06(22), I07(22), I08(22), I09(22), I10(22), I11(22), I12(22), I13(22), I14(22), I15(22), I16(22), I17(22), I18(22), I19(22), I20(22), I21(22), I22(22), I23(22), I24(22), I25(22), I26(22), I27(22), I28(22), I29(22), I30(22), I31(22),  SL, R(22));
M23:   MUX32 port map(I00(23), I01(23), I02(23), I03(23), I04(23), I05(23), I06(23), I07(23), I08(23), I09(23), I10(23), I11(23), I12(23), I13(23), I14(23), I15(23), I16(23), I17(23), I18(23), I19(23), I20(23), I21(23), I22(23), I23(23), I24(23), I25(23), I26(23), I27(23), I28(23), I29(23), I30(23), I31(23),  SL, R(23));
M24:   MUX32 port map(I00(24), I01(24), I02(24), I03(24), I04(24), I05(24), I06(24), I07(24), I08(24), I09(24), I10(24), I11(24), I12(24), I13(24), I14(24), I15(24), I16(24), I17(24), I18(24), I19(24), I20(24), I21(24), I22(24), I23(24), I24(24), I25(24), I26(24), I27(24), I28(24), I29(24), I30(24), I31(24),  SL, R(24));
M25:   MUX32 port map(I00(25), I01(25), I02(25), I03(25), I04(25), I05(25), I06(25), I07(25), I08(25), I09(25), I10(25), I11(25), I12(25), I13(25), I14(25), I15(25), I16(25), I17(25), I18(25), I19(25), I20(25), I21(25), I22(25), I23(25), I24(25), I25(25), I26(25), I27(25), I28(25), I29(25), I30(25), I31(25),  SL, R(25));
M26:   MUX32 port map(I00(26), I01(26), I02(26), I03(26), I04(26), I05(26), I06(26), I07(26), I08(26), I09(26), I10(26), I11(26), I12(26), I13(26), I14(26), I15(26), I16(26), I17(26), I18(26), I19(26), I20(26), I21(26), I22(26), I23(26), I24(26), I25(26), I26(26), I27(26), I28(26), I29(26), I30(26), I31(26),  SL, R(26));
M27:   MUX32 port map(I00(27), I01(27), I02(27), I03(27), I04(27), I05(27), I06(27), I07(27), I08(27), I09(27), I10(27), I11(27), I12(27), I13(27), I14(27), I15(27), I16(27), I17(27), I18(27), I19(27), I20(27), I21(27), I22(27), I23(27), I24(27), I25(27), I26(27), I27(27), I28(27), I29(27), I30(27), I31(27),  SL, R(27));
M28:   MUX32 port map(I00(28), I01(28), I02(28), I03(28), I04(28), I05(28), I06(28), I07(28), I08(28), I09(28), I10(28), I11(28), I12(28), I13(28), I14(28), I15(28), I16(28), I17(28), I18(28), I19(28), I20(28), I21(28), I22(28), I23(28), I24(28), I25(28), I26(28), I27(28), I28(28), I29(28), I30(28), I31(28),  SL, R(28));
M29:   MUX32 port map(I00(29), I01(29), I02(29), I03(29), I04(29), I05(29), I06(29), I07(29), I08(29), I09(29), I10(29), I11(29), I12(29), I13(29), I14(29), I15(29), I16(29), I17(29), I18(29), I19(29), I20(29), I21(29), I22(29), I23(29), I24(29), I25(29), I26(29), I27(29), I28(29), I29(29), I30(29), I31(29),  SL, R(29));
M30:   MUX32 port map(I00(30), I01(30), I02(30), I03(30), I04(30), I05(30), I06(30), I07(30), I08(30), I09(30), I10(30), I11(30), I12(30), I13(30), I14(30), I15(30), I16(30), I17(30), I18(30), I19(30), I20(30), I21(30), I22(30), I23(30), I24(30), I25(30), I26(30), I27(30), I28(30), I29(30), I30(30), I31(30),  SL, R(30));
M31:   MUX32 port map(I00(31), I01(31), I02(31), I03(31), I04(31), I05(31), I06(31), I07(31), I08(31), I09(31), I10(31), I11(31), I12(31), I13(31), I14(31), I15(31), I16(31), I17(31), I18(31), I19(31), I20(31), I21(31), I22(31), I23(31), I24(31), I25(31), I26(31), I27(31), I28(31), I29(31), I30(31), I31(31),  SL, R(31));   
    
end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------