library work;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

---------------------------------------------------------------------------

entity simplecontrol_tb is
end simplecontrol_tb;

---------------------------------------------------------------------------

architecture struct of simplecontrol_tb is

---------------------------------------------------------------------------
-- COMPONENT HERE

component simplecontrol is
port
(
	-- PORT DEFINITION HERE (COPY!!!)
   rst:         in std_logic;
   opcode:       in std_logic_vector(5 downto 0);
   func:         in std_logic_vector(5 downto 0);
   ALUOpcode: in std_logic_vector(2 downto 0);
   ALUOvf:     in std_logic;
   
   C_FDFlush:    out std_logic;
   C_DEFlush:    out std_logic;
   C_EMFlush:    out std_logic;
   C_Exception:  out std_logic;
   C_Jump:       out std_logic;
   C_DBranch:    out std_logic;
   C_RAdr3Src:   out std_logic;
   C_RData3Src:  out std_logic;
   C_BeqBne:     out std_logic;
   C_JmpType:    out std_logic;
   C_ALUOpcode:  out std_logic_vector(2 downto 0);
   C_DstRegMux:  out std_logic;
   C_Op2SrcMux:  out std_logic;
   C_MemWrite:   out std_logic;
   C_MemAluMux:    out std_logic;
   C_RegWrite:   out std_logic;
   C_EPCSrc:     out std_logic;
   C_EPCWrite:   out std_logic;
   C_CauseWrite: out std_logic;
   C_Cause:      out std_logic
);
end component simplecontrol;

---------------------------------------------------------------------------
-- SIGNALS HERE
signal   rst:          std_logic;
signal   opcode:       std_logic_vector(5 downto 0);
signal   func:         std_logic_vector(5 downto 0);
signal   ALUOpcode:    std_logic_vector(2 downto 0);
signal   ALUOvf:       std_logic;
  
signal   C_FDFlush:    std_logic;
signal   C_DEFlush:    std_logic;
signal   C_EMFlush:    std_logic;
signal   C_Exception:  std_logic;
signal   C_Jump:       std_logic;
signal   C_DBranch:    std_logic;
signal   C_RAdr3Src:   std_logic;
signal   C_RData3Src:  std_logic;
signal   C_BeqBne:     std_logic;
signal   C_JmpType:    std_logic;
signal   C_ALUOpcode:  std_logic_vector(2 downto 0);
signal   C_DstRegMux:  std_logic;
signal   C_Op2SrcMux:  std_logic;
signal   C_MemWrite:   std_logic;
signal   C_MemAluMux:    std_logic;
signal   C_RegWrite:   std_logic;
signal   C_EPCSrc:     std_logic;
signal   C_EPCWrite:   std_logic;
signal   C_CauseWrite: std_logic;
signal   C_Cause:      std_logic;
---------------------------------------------------------------------------

begin  -- struct

	-- INSTANTIATE HERE
dut: simplecontrol port map
(
Rst,
Opcode,
Func,
ALUOpcode,
ALUOvf,

C_FDFlush,
C_DEFlush,
C_EMFlush,
C_Exception,
C_Jump,
C_DBranch,
C_RAdr3Src,
C_RData3Src,
C_BeqBne,
C_JmpType,
C_ALUOpcode,
C_DstRegMux,
C_Op2SrcMux,
C_MemWrite,
C_MemAluMux,
C_RegWrite,
C_EPCSrc,
C_EPCWrite,
C_CauseWrite,
C_Cause
);

process
begin  -- process

Rst       <= '0';
Opcode    <= "000000";
Func      <= "000000";
ALUOpcode <= "000";
ALUOvf    <= '0';
wait for 10 ns;

--Rst       <= '';
--Opcode    <= "";
--Func      <= "";
--ALUOpcode <= "";
--ALUOvf    <= '';
--wait for 10 ns;

end process;

end struct;
