-------------------------------------------------------------------------------
-- File name : gates.vhdl
-- Title     : gates
-- project   : IFPU
-- Library   : gates
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of package gates and its architectures
-- notes :   

-- Copyright Lehigh University
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

-- 4 gate Half Adder
entity halfadder is
    port (A    : in  std_logic;
          B    : in  std_logic;
          Sum  : out std_logic;
          Cout : out std_logic);
end halfadder;

architecture structure of halfadder is

  signal w1 : std_logic;
  
begin
    w1   <= A and B;
    Sum  <= (A or B) and not w1;
    Cout <= w1;
end structure;

