-------------------------------------------------------------------------------
-- File name : mux81.vhdl
-- Title     : 8-1 Multiplexor
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity mux81 is
  port (D0 : in  std_logic;
        D1 : in  std_logic;
        D2 : in  std_logic;
        D3 : in  std_logic;
        D4 : in  std_logic;
        D5 : in  std_logic;
        D6 : in  std_logic;
        D7 : in  std_logic;        
        S  : in  std_logic_vector(2 downto 0);
        Y  : out std_logic);
end mux81;

architecture structure of mux81 is

  component mux21
    port (D0 : in  std_logic;
          D1 : in  std_logic;
          S0 : in  std_logic;
          Y  : out std_logic);
  end component;

  signal w1, w2, w3, w4, w5, w6 : std_logic;
  
begin

  mx1 : mux21 port map (D0, D1, S(0), w1);
  mx2 : mux21 port map (D2, D3, S(0), w2);
  mx3 : mux21 port map (D4, D5, S(0), w3);
  mx4 : mux21 port map (D6, D7, S(0), w4);

  mx5 : mux21 port map (w1, w2, S(1), w5);
  mx6 : mux21 port map (w3, w4, S(1), w6);

  mx7 : mux21 port map (w5, w6, S(2), Y);    

end structure;
